Index: extensions/jiwigo-ws-api/.classpath
===================================================================
--- extensions/jiwigo-ws-api/.classpath	(revision 9902)
+++ extensions/jiwigo-ws-api/.classpath	(revision 9919)
@@ -5,17 +5,11 @@
   <classpathentry kind="src" path="src/main/resources" excluding="**/*.java"/>
   <classpathentry kind="output" path="target/classes"/>
-  <classpathentry kind="var" path="M2_REPO/javax/servlet/servlet-api/2.3/servlet-api-2.3.jar"/>
-  <classpathentry kind="var" path="M2_REPO/avalon-framework/avalon-framework/4.1.3/avalon-framework-4.1.3.jar"/>
-  <classpathentry kind="var" path="M2_REPO/commons-beanutils/commons-beanutils/1.8.3/commons-beanutils-1.8.3.jar"/>
   <classpathentry kind="var" path="M2_REPO/commons-codec/commons-codec/1.4/commons-codec-1.4.jar"/>
   <classpathentry kind="var" path="M2_REPO/commons-lang/commons-lang/2.5/commons-lang-2.5.jar"/>
-  <classpathentry kind="var" path="M2_REPO/commons-logging/commons-logging/1.1/commons-logging-1.1.jar"/>
+  <classpathentry kind="var" path="M2_REPO/commons-logging/commons-logging/1.1.1/commons-logging-1.1.1.jar"/>
   <classpathentry kind="var" path="M2_REPO/org/apache/httpcomponents/httpclient/4.1/httpclient-4.1.jar"/>
   <classpathentry kind="var" path="M2_REPO/org/apache/httpcomponents/httpcore/4.1/httpcore-4.1.jar"/>
-  <classpathentry kind="var" path="M2_REPO/junit/junit/4.8.1/junit-4.8.1.jar"/>
-  <classpathentry kind="var" path="M2_REPO/log4j/log4j/1.2.16/log4j-1.2.16.jar"/>
-  <classpathentry kind="var" path="M2_REPO/logkit/logkit/1.0.1/logkit-1.0.1.jar"/>
-  <classpathentry kind="var" path="M2_REPO/com/drew/metadata-extractor/2.3.1/metadata-extractor-2.3.1.jar"/>
   <classpathentry kind="var" path="M2_REPO/org/apache/sanselan/sanselan/0.97-incubator/sanselan-0.97-incubator.jar"/>
+  <classpathentry kind="var" path="M2_REPO/org/slf4j/slf4j-api/1.6.1/slf4j-api-1.6.1.jar"/>
   <classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER/org.eclipse.jdt.internal.debug.ui.launcher.StandardVMType/java-6-openjdk"/>
 </classpath>
Index: extensions/jiwigo-ws-api/.project
===================================================================
--- extensions/jiwigo-ws-api/.project	(revision 9902)
+++ extensions/jiwigo-ws-api/.project	(revision 9919)
@@ -1,23 +1,17 @@
-<?xml version="1.0" encoding="UTF-8"?>
 <projectDescription>
-	<name>jiwigo-ws-api</name>
-	<comment>NO_M2ECLIPSE_SUPPORT: Project files created with the maven-eclipse-plugin are not supported in M2Eclipse.</comment>
-	<projects>
-	</projects>
-	<buildSpec>
-		<buildCommand>
-			<name>org.eclipse.jdt.core.javabuilder</name>
-			<arguments>
-			</arguments>
-		</buildCommand>
-		<buildCommand>
-			<name>org.maven.ide.eclipse.maven2Builder</name>
-			<arguments>
-			</arguments>
-		</buildCommand>
-	</buildSpec>
-	<natures>
-		<nature>org.maven.ide.eclipse.maven2Nature</nature>
-		<nature>org.eclipse.jdt.core.javanature</nature>
-	</natures>
+  <name>jiwigo-ws-api</name>
+  <comment>NO_M2ECLIPSE_SUPPORT: Project files created with the maven-eclipse-plugin are not supported in M2Eclipse.</comment>
+  <projects/>
+  <buildSpec>
+    <buildCommand>
+      <name>org.eclipse.jdt.core.javabuilder</name>
+    </buildCommand>
+    <buildCommand>
+      <name>org.maven.ide.eclipse.maven2Builder</name>
+    </buildCommand>
+  </buildSpec>
+  <natures>
+    <nature>org.maven.ide.eclipse.maven2Nature</nature>
+    <nature>org.eclipse.jdt.core.javanature</nature>
+  </natures>
 </projectDescription>
Index: extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/CategoryDao.java
===================================================================
--- extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/CategoryDao.java	(revision 9902)
+++ extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/CategoryDao.java	(revision 9919)
@@ -2,65 +2,10 @@
 
 import java.io.IOException;
-import java.util.ArrayList;
 import java.util.List;
 
-import org.w3c.dom.Document;
-import org.w3c.dom.Element;
-import org.w3c.dom.Node;
-import org.w3c.dom.NodeList;
+import fr.mael.jiwigo.om.Category;
+import fr.mael.jiwigo.transverse.exception.ProxyAuthenticationException;
 
-import fr.mael.jiwigo.om.Category;
-import fr.mael.jiwigo.transverse.enumeration.CategoryEnum;
-import fr.mael.jiwigo.transverse.enumeration.MethodsEnum;
-import fr.mael.jiwigo.transverse.exception.FileAlreadyExistsException;
-import fr.mael.jiwigo.transverse.exception.ProxyAuthenticationException;
-import fr.mael.jiwigo.transverse.session.SessionManager;
-import fr.mael.jiwigo.transverse.util.Tools;
-
-/*
- *  jiwigo-ws-api Piwigo webservice access Api
- *  Copyright (c) 2010-2011 Mael mael@le-guevel.com
- *                All Rights Reserved
- *
- *  This library is free software. It comes without any warranty, to
- *  the extent permitted by applicable law. You can redistribute it
- *  and/or modify it under the terms of the Do What The Fuck You Want
- *  To Public License, Version 2, as published by Sam Hocevar. See
- *  http://sam.zoy.org/wtfpl/COPYING for more details.
- */
-/**
- * Dao for the categories
- * @author mael
- *
- */
-public class CategoryDao {
-    /**
-     * Logger
-     */
-    public static final org.apache.commons.logging.Log LOG = org.apache.commons.logging.LogFactory
-	    .getLog(CategoryDao.class);
-    /**
-     * Instance to use a singleton
-     */
-    private static CategoryDao instance;
-
-    private SessionManager sessionManager;
-
-    /**
-     * Private constructor to use a singleton
-     */
-    private CategoryDao(SessionManager sessionManager) {
-	this.sessionManager = sessionManager;
-    }
-
-    /**
-     * @return the instance
-     */
-    public static CategoryDao getInstance(SessionManager sessionManager) {
-	if (instance == null) {
-	    instance = new CategoryDao(sessionManager);
-	}
-	return instance;
-    }
+public interface CategoryDao {
 
     /**
@@ -71,34 +16,5 @@
      * @throws ProxyAuthenticationException
      */
-    public List<Category> list(boolean recursive) throws IOException, ProxyAuthenticationException {
-	Document doc = sessionManager.executeReturnDocument(MethodsEnum.LISTER_CATEGORIES.getLabel(), "recursive",
-		String.valueOf(recursive));
-	Element element = (Element) doc.getDocumentElement().getElementsByTagName("categories").item(0);
-	NodeList nodeList = element.getElementsByTagName("category");
-	ArrayList<Category> categories = new ArrayList<Category>();
-	for (int i = 0; i < nodeList.getLength(); i++) {
-	    Node catNode = nodeList.item(i);
-	    if (catNode.getNodeType() == Node.ELEMENT_NODE) {
-		Element cat = (Element) catNode;
-		Category myCat = new Category();
-		myCat.setIdentifier(Integer.valueOf(cat.getAttribute(CategoryEnum.ID.getLabel())));
-		myCat.setUrlCategory(cat.getAttribute(CategoryEnum.URL.getLabel()));
-		myCat.setNbImages(Integer.valueOf(cat.getAttribute(CategoryEnum.NB_IMAGES.getLabel())));
-		myCat.setNbTotalImages(Integer.valueOf(cat.getAttribute(CategoryEnum.NB_TOTAL_IMAGES.getLabel())));
-		myCat.setName(Tools.getStringValueDom(cat, CategoryEnum.NAME.getLabel()));
-		String catMeres = Tools.getStringValueDom(cat, CategoryEnum.CAT_MERES.getLabel());
-		ArrayList<Integer> idCategoriesMeres = new ArrayList<Integer>();
-		myCat.setIdParentCategoriesString(catMeres);
-		for (String catA : catMeres.split(",")) {
-		    if (!catA.equals("")) {
-			idCategoriesMeres.add(Integer.valueOf(catA));
-		    }
-		}
-		myCat.setIdParentCategories(idCategoriesMeres);
-		categories.add(myCat);
-	    }
-	}
-	return categories;
-    }
+    public List<Category> list(boolean recursive) throws IOException, ProxyAuthenticationException;
 
     /**
@@ -108,20 +24,4 @@
      * @throws ProxyAuthenticationException
      */
-    public boolean create(Category category) throws ProxyAuthenticationException {
-	try {
-	    if (category.getDirectParent() != null) {
-		return Tools.checkOk(sessionManager.executeReturnDocument(MethodsEnum.AJOUTER_CATEGORIE.getLabel(),
-			"name", category.getName(), "parent", String.valueOf(category.getDirectParent())));
-	    } else {
-		return Tools.checkOk(sessionManager.executeReturnDocument(MethodsEnum.AJOUTER_CATEGORIE.getLabel(),
-			"name", category.getName()));
-	    }
-	} catch (IOException e) {
-	    LOG.error(Tools.getStackTrace(e));
-	} catch (FileAlreadyExistsException e) {
-	    LOG.error(Tools.getStackTrace(e));
-	}
-	return false;
-    }
-
+    public boolean create(Category category) throws ProxyAuthenticationException;
 }
Index: extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/CommentDao.java
===================================================================
--- extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/CommentDao.java	(revision 9902)
+++ extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/CommentDao.java	(revision 9919)
@@ -2,66 +2,10 @@
 
 import java.io.IOException;
-import java.util.ArrayList;
 import java.util.List;
 
-import org.w3c.dom.Document;
-import org.w3c.dom.Element;
-import org.w3c.dom.Node;
-import org.w3c.dom.NodeList;
+import fr.mael.jiwigo.om.Comment;
+import fr.mael.jiwigo.transverse.exception.ProxyAuthenticationException;
 
-import fr.mael.jiwigo.om.Comment;
-import fr.mael.jiwigo.transverse.enumeration.MethodsEnum;
-import fr.mael.jiwigo.transverse.exception.FileAlreadyExistsException;
-import fr.mael.jiwigo.transverse.exception.ProxyAuthenticationException;
-import fr.mael.jiwigo.transverse.session.SessionManager;
-import fr.mael.jiwigo.transverse.util.Tools;
-
-/*
- *  jiwigo-ws-api Piwigo webservice access Api
- *  Copyright (c) 2010-2011 Mael mael@le-guevel.com
- *                All Rights Reserved
- *
- *  This library is free software. It comes without any warranty, to
- *  the extent permitted by applicable law. You can redistribute it
- *  and/or modify it under the terms of the Do What The Fuck You Want
- *  To Public License, Version 2, as published by Sam Hocevar. See
- *  http://sam.zoy.org/wtfpl/COPYING for more details.
- */
-/**
-
- * Dao for the comments
- * @author mael
- *
- */
-public class CommentDao {
-    /**
-     * Logger
-     */
-    public static final org.apache.commons.logging.Log LOG = org.apache.commons.logging.LogFactory
-	    .getLog(CommentDao.class);
-    /**
-     *  Instance that allows to use a singleton
-     */
-    private static CommentDao instance;
-
-    private SessionManager sessionManager;
-
-    /**
-     * private constructor, to use a singleton
-     */
-    private CommentDao(SessionManager sessionManager) {
-	this.sessionManager = sessionManager;
-    }
-
-    /**
-     * @return the singleton
-     */
-    public static CommentDao getInstance(SessionManager sessionManager) {
-	if (instance == null) {
-	    instance = new CommentDao(sessionManager);
-	}
-	return instance;
-    }
-
+public interface CommentDao {
     /**
      * Listing of the comments for the given image
@@ -71,25 +15,5 @@
      * @throws ProxyAuthenticationException
      */
-    public List<Comment> list(Integer idImage) throws IOException, ProxyAuthenticationException {
-	Document doc = (sessionManager.executeReturnDocument(MethodsEnum.GET_INFO.getLabel(), "image_id", String
-		.valueOf(idImage), "comments_per_page", "100"));
-	Element elementImage = (Element) doc.getDocumentElement().getElementsByTagName("image").item(0);
-	Element elementComments = (Element) elementImage.getElementsByTagName("comments").item(0);
-	NodeList listComments = elementComments.getElementsByTagName("comment");
-	ArrayList<Comment> comments = new ArrayList<Comment>();
-	for (int i = 0; i < listComments.getLength(); i++) {
-	    Node nodeCom = listComments.item(i);
-	    if (nodeCom.getNodeType() == Node.ELEMENT_NODE) {
-		Element com = (Element) nodeCom;
-		Comment myCom = new Comment();
-		myCom.setIdentifier(Integer.valueOf(com.getAttribute("id")));
-		myCom.setDate(com.getAttribute("date"));
-		myCom.setAuthor(Tools.getStringValueDom(com, "author"));
-		myCom.setContent(Tools.getStringValueDom(com, "content"));
-		comments.add(myCom);
-	    }
-	}
-	return comments;
-    }
+    public List<Comment> list(Integer idImage) throws IOException, ProxyAuthenticationException;
 
     /**
@@ -100,12 +24,5 @@
      * @throws ProxyAuthenticationException
      */
-    public String getKey(Integer idImage) throws IOException, ProxyAuthenticationException {
-	Document doc = (sessionManager.executeReturnDocument(MethodsEnum.GET_INFO.getLabel(), "image_id", String
-		.valueOf(idImage)));
-	//	String key = doc.getRootElement().getChild("image").getChild("comment_post").getAttributeValue("key");
-	Element elementImage = (Element) doc.getDocumentElement().getElementsByTagName("image").item(0);
-	Element elementCommentPost = (Element) elementImage.getElementsByTagName("comment_post").item(0);
-	return elementCommentPost.getAttribute("key");
-    }
+    public String getKey(Integer idImage) throws IOException, ProxyAuthenticationException;
 
     /**
@@ -116,20 +33,4 @@
      * @throws ProxyAuthenticationException
      */
-    public boolean create(Comment commentaire) throws IOException, ProxyAuthenticationException {
-	String key = getKey(commentaire.getImageId());
-	try {
-	    Thread.sleep(2200);
-	} catch (InterruptedException e) {
-	    e.printStackTrace();
-	}
-	try {
-	    return Tools.checkOk(sessionManager.executeReturnDocument(MethodsEnum.AJOUTER_COMMENTAIRE.getLabel(),
-		    "image_id", String.valueOf(commentaire.getImageId()), "author", commentaire.getAuthor(), "content",
-		    commentaire.getContent(), "key", key));
-	} catch (FileAlreadyExistsException e) {
-	    LOG.error(Tools.getStackTrace(e));
-	    return false;
-	}
-
-    }
+    public boolean create(Comment commentaire) throws IOException, ProxyAuthenticationException;
 }
Index: extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/ImageDao.java
===================================================================
--- extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/ImageDao.java	(revision 9902)
+++ extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/ImageDao.java	(revision 9919)
@@ -1,87 +1,14 @@
 package fr.mael.jiwigo.dao;
 
-import java.io.File;
 import java.io.IOException;
 import java.security.NoSuchAlgorithmException;
-import java.util.ArrayList;
-import java.util.HashMap;
 import java.util.List;
 
-import org.w3c.dom.Document;
-import org.w3c.dom.Element;
-import org.w3c.dom.Node;
-import org.w3c.dom.NodeList;
-
-import sun.misc.BASE64Encoder;
 import fr.mael.jiwigo.om.Image;
-import fr.mael.jiwigo.transverse.enumeration.MethodsEnum;
 import fr.mael.jiwigo.transverse.exception.FileAlreadyExistsException;
 import fr.mael.jiwigo.transverse.exception.ProxyAuthenticationException;
 import fr.mael.jiwigo.transverse.exception.WrongChunkSizeException;
-import fr.mael.jiwigo.transverse.session.SessionManager;
-import fr.mael.jiwigo.transverse.util.Tools;
 
-/*
- *  jiwigo-ws-api Piwigo webservice access Api
- *  Copyright (c) 2010-2011 Mael mael@le-guevel.com
- *                All Rights Reserved
- *
- *  This library is free software. It comes without any warranty, to
- *  the extent permitted by applicable law. You can redistribute it
- *  and/or modify it under the terms of the Do What The Fuck You Want
- *  To Public License, Version 2, as published by Sam Hocevar. See
- *  http://sam.zoy.org/wtfpl/COPYING for more details.
- */
-/**
-
- * Dao of the images
- * @author mael
- *
- */
-public class ImageDao {
-
-    /**
-     * Logger
-     */
-    public static final org.apache.commons.logging.Log LOG = org.apache.commons.logging.LogFactory
-	    .getLog(ImageDao.class);
-
-    /**
-     * Singleton
-     */
-    private static ImageDao instance;
-
-    /**
-     * cache to avoid downloading image for each access
-     */
-    private HashMap<Integer, List<Image>> cache;
-
-    /**
-     *
-     */
-    private Integer firstCatInCache;
-
-    private SessionManager sessionManager;
-
-    private ArrayList<File> filesToSend;
-
-    /**
-     * Private singleton, to use a singleton
-     */
-    private ImageDao(SessionManager sessionManager) {
-	cache = new HashMap<Integer, List<Image>>();
-	this.sessionManager = sessionManager;
-    }
-
-    /**
-     * @return le singleton
-     */
-    public static ImageDao getInstance(SessionManager sessionManager) {
-	if (instance == null) {
-	    instance = new ImageDao(sessionManager);
-	}
-	return instance;
-    }
-
+public interface ImageDao {
     /**
      * Lists all images
@@ -90,7 +17,5 @@
      * @throws ProxyAuthenticationException
      */
-    public List<Image> list(boolean refresh) throws IOException, ProxyAuthenticationException {
-	return listByCategory(null, refresh);
-    }
+    public List<Image> list(boolean refresh) throws IOException, ProxyAuthenticationException;
 
     /**
@@ -102,25 +27,5 @@
      */
     public List<Image> listByCategory(Integer categoryId, boolean refresh) throws IOException,
-	    ProxyAuthenticationException {
-	if (refresh || cache.get(categoryId) == null) {
-	    Document doc = null;
-	    if (categoryId != null) {
-		doc = sessionManager.executeReturnDocument(MethodsEnum.LISTER_IMAGES.getLabel(), "cat_id", String
-			.valueOf(categoryId));
-	    } else {
-		doc = sessionManager.executeReturnDocument(MethodsEnum.LISTER_IMAGES.getLabel());
-	    }
-	    Element element = (Element) doc.getDocumentElement().getElementsByTagName("images").item(0);
-	    List<Image> images = getImagesFromElement(element);
-	    cache.remove(categoryId);
-	    cache.put(categoryId, images);
-	    if (firstCatInCache == null) {
-		firstCatInCache = categoryId;
-	    }
-	    return images;
-	} else {
-	    return cache.get(categoryId);
-	}
-    }
+	    ProxyAuthenticationException;
 
     /**
@@ -143,58 +48,5 @@
     //TODO ne pas continuer si une des reponses precedentes est negative
     public boolean create(Image image, Double chunkSize) throws FileAlreadyExistsException, IOException,
-	    ProxyAuthenticationException, NoSuchAlgorithmException, WrongChunkSizeException {
-	//thumbnail converted to base64
-	BASE64Encoder base64 = new BASE64Encoder();
-
-	String thumbnailBase64 = base64.encode(Tools.getBytesFromFile(image.getThumbnail()));
-	//sends the thumbnail and gets the result
-	Document reponseThumb = (sessionManager.executeReturnDocument("pwg.images.addChunk", "data", thumbnailBase64,
-		"type", "thumb", "position", "1", "original_sum", Tools.getMD5Checksum(image.getOriginale()
-			.getAbsolutePath())));
-
-	//begin feature:0001827
-	int chunk = chunkSize.intValue();
-	if (chunk == 0) {
-	    throw new WrongChunkSizeException("Error : the chunk size cannot be 0");
-	}
-	filesToSend = Tools.splitFile(image.getOriginale(), chunk);
-	boolean echec = false;
-	for (int i = 0; i < filesToSend.size(); i++) {
-	    File fichierAEnvoyer = filesToSend.get(i);
-	    String originaleBase64 = base64.encode(Tools.getBytesFromFile(fichierAEnvoyer));
-	    Document reponseOriginale = (sessionManager.executeReturnDocument("pwg.images.addChunk", "data",
-		    originaleBase64, "type", "file", "position", String.valueOf(i), "original_sum", Tools
-			    .getMD5Checksum(image.getOriginale().getAbsolutePath())));
-	    if (!Tools.checkOk(reponseOriginale)) {
-		echec = true;
-		break;
-	    }
-	}
-	//end
-
-	//add the image in the database and get the result of the webservice
-	Document reponseAjout = (sessionManager.executeReturnDocument("pwg.images.add", "file_sum", Tools
-		.getMD5Checksum(image.getOriginale().getAbsolutePath()), "thumbnail_sum", Tools.getMD5Checksum(image
-		.getThumbnail().getCanonicalPath()), "position", "1", "original_sum", Tools.getMD5Checksum(image
-		.getOriginale().getAbsolutePath()), "categories", String.valueOf(image.getIdCategory()), "name", image
-		.getName(), "author", sessionManager.getLogin(), "level", image.getPrivacyLevel()));
-	LOG.debug("Response add : " + Tools.documentToString(reponseAjout));
-	//	System.out.println(Main.sessionManager.executerReturnString("pwg.images.add", "file_sum", Outil
-	//		.getMD5Checksum(image.getOriginale().getAbsolutePath()), "thumbnail_sum", Outil.getMD5Checksum(image
-	//		.getThumbnail().getCanonicalPath()), "position", "1", "original_sum", Outil.getMD5Checksum(image
-	//		.getOriginale().getAbsolutePath()), "categories", String.valueOf(image.getIdCategory()), "name", image
-	//		.getName(), "author", Main.sessionManager.getLogin()));
-	//	Document reponsePrivacy = null;
-	//	if (Outil.checkOk(reponseAjout)) {
-	//	    reponsePrivacy = Main.sessionManager.executerReturnDocument(MethodsEnum.SET_PRIVACY_LEVEL.getLabel());
-	//	}
-	boolean reussite = true;
-	if (!Tools.checkOk(reponseThumb) || echec || !Tools.checkOk(reponseAjout)) {
-	    reussite = false;
-	}
-	deleteTempFiles();
-	return reussite;
-
-    }
+	    ProxyAuthenticationException, NoSuchAlgorithmException, WrongChunkSizeException;
 
     /**
@@ -205,49 +57,5 @@
      * @throws ProxyAuthenticationException
      */
-    public boolean addTags(Integer imageId, String tagId) throws IOException, ProxyAuthenticationException {
-	Document doc = sessionManager.executeReturnDocument(MethodsEnum.SET_INFO.getLabel(), "image_id", String
-		.valueOf(imageId), "tag_ids", tagId);
-	try {
-	    return Tools.checkOk(doc);
-	} catch (FileAlreadyExistsException e) {
-	    LOG.error(Tools.getStackTrace(e));
-	    return false;
-	}
-
-    }
-
-    /**
-     * parse an element to find images
-     * @param element the element to parse
-     * @return the list of images
-     */
-    private List<Image> getImagesFromElement(Element element) {
-	//	List<Element> listElement = (List<Element>) element.getChildren("image");
-	NodeList listImages = element.getElementsByTagName("image");
-	ArrayList<Image> images = new ArrayList<Image>();
-	for (int i = 0; i < listImages.getLength(); i++) {
-	    Node nodeImage = listImages.item(i);
-	    if (nodeImage.getNodeType() == Node.ELEMENT_NODE) {
-		Element im = (Element) nodeImage;
-		Image myImage = new Image();
-		myImage.setThumbnailUrl(im.getAttribute("tn_url"));
-		myImage.setUrl(im.getAttribute("element_url"));
-		myImage.setWidth(Integer.valueOf(im.getAttribute("width")));
-		myImage.setHeight(Integer.valueOf(im.getAttribute("height")));
-		myImage.setFile(im.getAttribute("file"));
-		myImage.setSeen(Integer.valueOf(im.getAttribute("hit")));
-		myImage.setIdentifier(Integer.valueOf(im.getAttribute("id")));
-		myImage.setName(Tools.getStringValueDom(im, "name"));
-		Element elementCategories = (Element) im.getElementsByTagName("categories").item(0);
-		Element elementCategory = (Element) elementCategories.getElementsByTagName("category").item(0);
-		myImage.setIdCategory(Integer.valueOf(elementCategory.getAttribute("id")));
-		if (myImage.getName() == null) {
-		    myImage.setName(myImage.getFile());
-		}
-		images.add(myImage);
-	    }
-	}
-	return images;
-    }
+    public boolean addTags(Integer imageId, String tagId) throws IOException, ProxyAuthenticationException;
 
     /**
@@ -258,22 +66,5 @@
      * @throws ProxyAuthenticationException
      */
-    public List<Image> search(String searchString) throws IOException, ProxyAuthenticationException {
-	Document doc = sessionManager.executeReturnDocument(MethodsEnum.SEARCH.getLabel(), "query", searchString);
-	LOG.debug(doc);
-	Element element = (Element) doc.getDocumentElement().getElementsByTagName("images").item(0);
-	return getImagesFromElement(element);
-
-    }
-
-    private void deleteTempFiles() {
-	File file = new File(System.getProperty("java.io.tmpdir") + "/originale.jpg");
-	file.delete();
-	file = new File(System.getProperty("java.io.tmpdir") + "/thumb.jpg");
-	file.delete();
-	for (File tempCut : filesToSend) {
-	    tempCut.delete();
-	}
-
-    }
+    public List<Image> search(String searchString) throws IOException, ProxyAuthenticationException;
 
 }
Index: extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/TagDao.java
===================================================================
--- extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/TagDao.java	(revision 9902)
+++ extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/TagDao.java	(revision 9919)
@@ -2,66 +2,11 @@
 
 import java.io.IOException;
-import java.util.ArrayList;
 import java.util.List;
-
-import org.w3c.dom.Document;
-import org.w3c.dom.Element;
-import org.w3c.dom.Node;
-import org.w3c.dom.NodeList;
 
 import fr.mael.jiwigo.om.Image;
 import fr.mael.jiwigo.om.Tag;
-import fr.mael.jiwigo.transverse.enumeration.MethodsEnum;
-import fr.mael.jiwigo.transverse.enumeration.TagEnum;
-import fr.mael.jiwigo.transverse.exception.FileAlreadyExistsException;
 import fr.mael.jiwigo.transverse.exception.ProxyAuthenticationException;
-import fr.mael.jiwigo.transverse.session.SessionManager;
-import fr.mael.jiwigo.transverse.util.Tools;
 
-/*
- *  jiwigo-ws-api Piwigo webservice access Api
- *  Copyright (c) 2010-2011 Mael mael@le-guevel.com
- *                All Rights Reserved
- *
- *  This library is free software. It comes without any warranty, to
- *  the extent permitted by applicable law. You can redistribute it
- *  and/or modify it under the terms of the Do What The Fuck You Want
- *  To Public License, Version 2, as published by Sam Hocevar. See
- *  http://sam.zoy.org/wtfpl/COPYING for more details.
- */
-/**
- * Dao of the categories
- * @author mael
- *
- */
-public class TagDao {
-    /**
-     * Logger
-     */
-    public static final org.apache.commons.logging.Log LOG = org.apache.commons.logging.LogFactory.getLog(TagDao.class);
-    /**
-     * Instance, to use a singleton
-     */
-    private static TagDao instance;
-
-    private SessionManager sessionManager;
-
-    /**
-     * private constructor to use a singleton
-     */
-    private TagDao(SessionManager sessionManager) {
-	this.sessionManager = sessionManager;
-    }
-
-    /**
-     * @return the instance
-     */
-    public static TagDao getInstance(SessionManager sessionManager) {
-	if (instance == null) {
-	    instance = new TagDao(sessionManager);
-	}
-	return instance;
-    }
-
+public interface TagDao {
     /**
      * lists the tags
@@ -70,35 +15,5 @@
      * @throws ProxyAuthenticationException
      */
-    public List<Tag> list() throws IOException, ProxyAuthenticationException {
-	Document doc = sessionManager.executeReturnDocument(MethodsEnum.TAGS_ADMIN_LIST.getLabel());
-	//	System.out.println(Outil.documentToString(doc));
-
-	return getTagsFromDocument((Element) doc.getDocumentElement().getElementsByTagName("tags"));
-
-    }
-
-    /**
-     * COnstructs a list of tags from a document
-     * @param doc the document
-     * @return the list of tags
-     */
-    private List<Tag> getTagsFromDocument(Element element) {
-	NodeList listTags = element.getElementsByTagName("tag");
-
-	//	List<Element> listElement = (List<Element>) element.getChildren("tag");
-	ArrayList<Tag> tags = new ArrayList<Tag>();
-	for (int i = 0; i < listTags.getLength(); i++) {
-	    Node nodeTag = listTags.item(0);
-	    if (nodeTag.getNodeType() == Node.ELEMENT_NODE) {
-		Element tagElement = (Element) nodeTag;
-		Tag tag = new Tag();
-		tag.setIdentifier(Integer.valueOf(tagElement.getAttribute(TagEnum.ID.getLabel())));
-		tag.setName(tagElement.getAttribute(TagEnum.NAME.getLabel()));
-		tags.add(tag);
-	    }
-	}
-	return tags;
-
-    }
+    public List<Tag> list() throws IOException, ProxyAuthenticationException;
 
     /**
@@ -108,15 +23,5 @@
      * @throws ProxyAuthenticationException
      */
-    public boolean create(Tag tag) throws ProxyAuthenticationException {
-	try {
-	    return Tools.checkOk(sessionManager.executeReturnDocument(MethodsEnum.ADD_TAG.getLabel(), "name", tag
-		    .getName()));
-	} catch (IOException e) {
-	    LOG.error(Tools.getStackTrace(e));
-	} catch (FileAlreadyExistsException e) {
-	    e.printStackTrace();
-	}
-	return false;
-    }
+    public boolean create(Tag tag) throws ProxyAuthenticationException;
 
     /**
@@ -127,11 +32,4 @@
      * @throws ProxyAuthenticationException
      */
-    public List<Tag> tagsForImage(Image image) throws IOException, ProxyAuthenticationException {
-	Document doc = sessionManager.executeReturnDocument(MethodsEnum.GET_INFO.getLabel(), "image_id", String
-		.valueOf(image.getIdentifier()));
-	Element elementImage = (Element) doc.getDocumentElement().getElementsByTagName("image").item(0);
-	Element elementTag = (Element) elementImage.getElementsByTagName("tags").item(0);
-	return getTagsFromDocument(elementTag);
-    }
-
+    public List<Tag> tagsForImage(Image image) throws IOException, ProxyAuthenticationException;
 }
